# -- BEGIN COPYRIGHT --
# IBM SecureWay Firewall Version 4.2
# Licensed Materials - Property of IBM
#
# 5697-F48
#
# (C) Copyright IBM Corp. 1985, 1994, 1999 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# -- END COPYRIGHT --

#
# Program File: daemon-ef.sh
#

eval daemon=\""$1"\"
#echo '#Daemon: '"$daemon"
case "$daemon" in
	*/*)	pat=`echo "$daemon" | sed -e s@/@.@g`;;
	*)	pat="$daemon";;
esac

# code added 11/11/99 to check for these services in inetd
# to make sure that they're not commented out:
# 
# ptelnetd, pftpd, ibmfwrcs

INETD="/etc/inetd.conf"

if [ x"$pat" = x"inetd" ] ; then
  for i in ftp telnet ibmfwrcs 
  do
    grep "^$i" $INETD > /dev/null 2>&1
    if [ $? -eq 1 ] ; then
      echo "down"
      exit 0
    fi
  done
fi
    
ps -ef | awk '
BEGIN {VALUE="down"}
/'"$pat"'/ {
  	field=-1;
  	for (i = NF; i > 0 && field == -1; --i) {
  		if ($i ~ /[0-9].*:[0-9]/)
			field=i+1;
  	}
  	if (field != -1) {
  		cmd=$field
		if (cmd == "'"$daemon"'") {
			VALUE="up";
			next;
		}
  		nfn = split(cmd, fn, "/")
  		if (fn[nfn] == "'"$daemon"'" || fn[nfn] == "('"$daemon"')")
  			VALUE="up";
  	}
}
END {print VALUE;}'
exit 0
